<%@ Page language="c#" %>
<%@ Import Namespace="Sitecore.ListManagement.ContentSearch.Model" %>
<%@ Import Namespace="Sitecore.Analytics.Model.Entities" %>
<%@ Import Namespace="Sitecore.Support.ListManagement" %>
<!DOCTYPE html>
<script runat="server">

    protected void Page_Init()
    {
        var lists = ContactListReview.GetLists();
        foreach (var list in lists)
        {
            DropDownList1.Items.Add(new ListItem(list.Name + " " + list.Id, list.Id));
        }
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        //string listId = TextBox1.Text;
        string listId = DropDownList1.SelectedValue;
        var contacts = ContactListReview.GetContactsInMongo(listId);
        Label1.Text = "Contacts in mongo: " + contacts.Count();
        var indexContacts = ContactListReview.GetContactsFromIndex(listId);
        Label2.Text = "Contacts in index: " + indexContacts.Count();
        Label3.Text = "Contacts on item " + ContactListReview.GetRecipientCount(listId);
    }

    protected void Button2_Click(object sender, EventArgs e)
    {
        string listId = DropDownList1.SelectedValue;
        ContactListReview.UpdateContactsInIndex(listId);
        Response.Write("<b>Reindexing started. Use the List Manager Dashboard to check the status <a href='/sitecore/client/Applications/List%20Manager/Taskpages/Contact%20list?id=" + listId + "'  target='_blank' >link</a></b>");
    }

    protected void Button3_Click(object sender, EventArgs e)
    {
        string listId = DropDownList1.SelectedValue;
        var indexContacts = ContactListReview.GetContactsFromIndex(listId);
        foreach (ContactData contact in indexContacts)
        {
            TableRow row = new TableRow();

            TableCell cell = new TableCell();
            cell.Text = contact.ContactId.ToString();
            row.Cells.Add(cell);

            TableCell cell2 = new TableCell();
            cell2.Text = contact.Identifier;
            row.Cells.Add(cell2);

            Table1.Rows.Add(row);

        }
    }

    protected void Button4_Click(object sender, EventArgs e)
    {
        string listId = DropDownList1.SelectedValue;
        var indexContacts = ContactListReview.GetContactsInMongo(listId);
        foreach (IContact contact in indexContacts)
        {
            TableRow row = new TableRow();

            TableCell cell = new TableCell();
            cell.Text = contact.Id.ToString();
            row.Cells.Add(cell);

            TableCell cell2 = new TableCell();
            cell2.Text = contact.Identifiers.Identifier;
            row.Cells.Add(cell2);

            Table1.Rows.Add(row);

        }
    }

    protected void Button5_Click(object sender, EventArgs e)
    {
        string listId = DropDownList1.SelectedValue;
        ContactListReview.RemoveObsoleteContactsFromIndex(listId);
        Response.Write("<b>Removing obsolete contacts started. Use the List Manager Dashboard to check the status <a href='/sitecore/client/Applications/List%20Manager/Taskpages/Contact%20list?id=" + listId + "'  target='_blank' >link</a></b>");
    }

</script>

<html>
  <head>
    <title>ListManager test</title>
  </head>
  <body>
  <form runat="server">
      <div>
          <asp:DropDownList ID="DropDownList1" runat="server"></asp:DropDownList>
      </div>
      <hr />
      <div>
          <asp:Button ID="Button1" runat="server" Text="Check" OnClick="Button1_Click" />
          <asp:Button ID="Button2" runat="server" OnClick="Button2_Click"  Text="Reindex" />
		      <asp:Button ID="Button3" runat="server" Text="Show contacts in index" OnClick="Button3_Click" />
		      <asp:Button ID="Button4" runat="server" Text="Show contacts in Mongo" OnClick="Button4_Click" />
      <asp:Button ID="Button5" runat="server" Text="Remove obsolete contacts from index" OnClick="Button5_Click" />
    </div>
    <hr />
    <div>
      <asp:Label ID="Label1" runat="server" Text=""></asp:Label>
      </div>
      <div>
      <asp:Label ID="Label2" runat="server" Text=""></asp:Label>
    </div>
    <div>
      <asp:Label ID="Label3" runat="server" Text=""></asp:Label>
      </div>
    <asp:Table ID="Table1" runat="server"></asp:Table>
   </form>
  </body>
</html>
